Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/AdjModel.cxx
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/AdjModel.cxx	(revision 1025)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/AdjModel.cxx	(revision 1526)
@@ -17,7 +17,7 @@
 int Model::in_Vertex(const Vec3& p)
 {
-    Vertex *v = newVertex(p[X], p[Y], p[Z]);
-    bounds.addPoint(p);
-    return vertCount() - 1;
+	Vertex *v = newVertex(p[X], p[Y], p[Z]);
+	bounds.addPoint(p);
+	return vertCount() - 1;
 }
 
@@ -36,9 +36,9 @@
 int Model::in_Face(int a, int b, int c, int n1, int n2, int n3, int t1, int t2, int t3)
 {
-    Vertex *v1 = vertices(a-1);
-    Vertex *v2 = vertices(b-1);
-    Vertex *v3 = vertices(c-1);
-	
-    Face *t = newFace(v1, v2, v3);
+	Vertex *v1 = vertices(a-1);
+	Vertex *v2 = vertices(b-1);
+	Vertex *v3 = vertices(c-1);
+
+	Face *t = newFace(v1, v2, v3);
 
 	t->normals[0] = n1;
@@ -55,9 +55,9 @@
 int Model::miin_Face(int a, int b, int c)
 {
-    Vertex *v1 = vertices(a-1);
-    Vertex *v2 = vertices(b-1);
-    Vertex *v3 = vertices(c-1);
-	
-    Face *t = newFace(v1, v2, v3);
+	Vertex *v1 = vertices(a);
+	Vertex *v2 = vertices(b);
+	Vertex *v3 = vertices(c);
+
+	Face *t = newFace(v1, v2, v3);
 
 	t->normals[0] = a;
@@ -75,11 +75,14 @@
 int Model::in_FColor(const Vec3& c)
 {
-    Face *f = faces(faces.length()-1);
-
-    if( !f->props )
-	f->props = new FProp;
-
-    f->props->color = c;
-    return 0;
+	Face *f = faces(faces.length()-1);
+
+	if( !f->props )
+	{
+		f->props = new FProp;
+	}
+
+	f->props->color = c;
+
+	return 0;
 }
 #endif
@@ -88,11 +91,13 @@
 int Model::in_VColor(const Vec3& c)
 {
-    Vertex *v = vertices(vertices.length()-1);
-
-    if( !v->props )
-	v->props = new VProp;
-
-    v->props->color = c;
-    return 0;
+	Vertex *v = vertices(vertices.length()-1);
+
+	if( !v->props )
+	{
+		v->props = new VProp;
+	}
+
+	v->props->color = c;
+	return 0;
 }
 #endif
@@ -100,27 +105,29 @@
 Vec3 Model::synthesizeNormal(Vertex *v)
 {
-    Vec3 n(0,0,0);
-    int n_count = 0;
-
-    edge_buffer& edges = v->edgeUses();
-    for(int i=0; i<edges.length(); i++)
-    {
-	face_buffer& faces = edges(i)->faceUses();
-
-	for(int j=0; j<faces.length(); j++)
-	{
-	    n += faces(j)->plane().normal();
-	    n_count++;
-	}
-    }
-
-    if( n_count )
-	n /= (real)n_count;
-    else
-    {
+	Vec3 n(0,0,0);
+	int n_count = 0;
+
+	edge_buffer& edges = v->edgeUses();
+	for(int i=0; i<edges.length(); i++)
+	{
+		face_buffer& faces = edges(i)->faceUses();
+
+		for(int j=0; j<faces.length(); j++)
+		{
+			n += faces(j)->plane().normal();
+			n_count++;
+		}
+	}
+
+	if( n_count )
+	{
+		n /= (real)n_count;
+	}
+	else
+	{
 		std::cerr << "Vertex with no normals!!: " << v->uniqID;
 		std::cerr << " / " << v->tempID << std::endl;
-    }
-    return n;
+	}
+	return n;
 }
 
@@ -138,59 +145,62 @@
 Vertex *Model::newVertex(real x, real y, real z)
 {
-    Vertex *v = new Vertex(x, y, z);
-
-    v->vID = v->uniqID = vertices.add(v);
-
-/*    if( logfile && selected_output&OUTPUT_MODEL_DEFN )
-		*logfile << "v " << x << " " << y << " " << z << std::endl;
-*/
-    validVertCount++;
-
-    return v;
+	Vertex *v = new Vertex(x, y, z);
+
+	v->vID = v->uniqID = vertices.add(v);
+
+	/*    if( logfile && selected_output&OUTPUT_MODEL_DEFN )
+	 *logfile << "v " << x << " " << y << " " << z << std::endl;
+	 */
+	validVertCount++;
+
+	return v;
 }
 
 Edge *Model::newEdge(Vertex *a, Vertex *b)
 {
-    Edge *e = new Edge(a, b);
-
-    e->uniqID = edges.add(e);
-    e->sym()->uniqID = e->uniqID;
-
-    validEdgeCount++;
-
-    return e;
+	Edge *e = new Edge(a, b);
+
+	e->uniqID = edges.add(e);
+	e->sym()->uniqID = e->uniqID;
+
+	validEdgeCount++;
+
+	return e;
 }
 
 static Edge *get_edge(Model *m, Vertex *org, Vertex *v)
 {
-    edge_buffer& edge_uses = org->edgeUses();
-
-    for(int i=0; i<edge_uses.length(); i++)
-	if( edge_uses(i)->dest() == v )
-	    return edge_uses(i);
-
-    Edge *e = m->newEdge(org, v);
-
-    return e;
-}
-
+	edge_buffer& edge_uses = org->edgeUses();
+
+	for (int i=0; i<edge_uses.length(); i++)
+	{
+		if ( edge_uses(i)->dest() == v )
+		{
+			return edge_uses(i);
+		}
+	}
+
+	Edge *e = m->newEdge(org, v);
+
+	return e;
+}
 
 Face *Model::newFace(Vertex *v1, Vertex *v2, Vertex *v3)
 {
-    Edge *e0 = get_edge(this, v1, v2);   // v1->edgeTo(m, v2);
-    Edge *e1 = get_edge(this, v2, v3);   // v2->edgeTo(m, v3);
-    Edge *e2 = get_edge(this, v3, v1);   // v3->edgeTo(m, v1);
-  
-    Face *t = new Face(e0, e1, e2);
-
-    t->uniqID = faces.add(t);
-
-/*    if( logfile && selected_output&OUTPUT_MODEL_DEFN )
-	*logfile << "f " << v1->uniqID+1 << " "
-	<< v2->uniqID+1 << " " << v3->uniqID+1 << std::endl;
-*/
-    validFaceCount++;
-
-    return t;
+	Edge *e0 = get_edge(this, v1, v2);   // v1->edgeTo(m, v2);
+	Edge *e1 = get_edge(this, v2, v3);   // v2->edgeTo(m, v3);
+	Edge *e2 = get_edge(this, v3, v1);   // v3->edgeTo(m, v1);
+
+	Face *t = new Face(e0, e1, e2);
+
+	t->uniqID = faces.add(t);
+
+	/*    if( logfile && selected_output&OUTPUT_MODEL_DEFN )
+	 *logfile << "f " << v1->uniqID+1 << " "
+	 << v2->uniqID+1 << " " << v3->uniqID+1 << std::endl;
+	 */
+	validFaceCount++;
+
+	return t;
 }
 
@@ -198,43 +208,45 @@
 void Model::killVertex(Vertex *v)
 {
-    if( v->isValid() )
-    {
-/*	if( logfile && selected_output&OUTPUT_CONTRACTIONS )
-		*logfile << "v- " << v->uniqID+1 << std::endl;
-*/
-	v->kill();
-	validVertCount--;
-    }
+	if( v->isValid() )
+	{
+		/*	if( logfile && selected_output&OUTPUT_CONTRACTIONS )
+		 *logfile << "v- " << v->uniqID+1 << std::endl;
+		 */
+		v->kill();
+		validVertCount--;
+	}
 }
 
 void Model::killEdge(Edge *e)
 {
-    if( e->isValid() )
-    {
-	e->kill();
-	validEdgeCount--;
-    }
+	if( e->isValid() )
+	{
+		e->kill();
+		validEdgeCount--;
+	}
 }
 
 void Model::killFace(Face *f)
 {
-    if( f->isValid() )
-    {
-/*	if( logfile && selected_output&OUTPUT_CONTRACTIONS )
-		*logfile << "f- " << f->uniqID+1 << std::endl;
-*/
-	f->kill();
-	validFaceCount--;
-    }
+	if( f->isValid() )
+	{
+		/*	if( logfile && selected_output&OUTPUT_CONTRACTIONS )
+		 *logfile << "f- " << f->uniqID+1 << std::endl;
+		 */
+		f->kill();
+		validFaceCount--;
+	}
 }
 
 void Model::reshapeVertex(Vertex *v, real x, real y, real z)
 {
-    v->set(x, y, z);
+	v->set(x, y, z);
 
 #ifdef LOG_LOWLEVEL_OPS
-    if( logfile )
-	*logfile << "v! " << v->uniqID+1 << " "
-		 << x << " " << y << " " << z << endl;
+	if( logfile )
+	{
+		*logfile << "v! " << v->uniqID+1 << " "
+			<< x << " " << y << " " << z << endl;
+	}
 #endif
 }
@@ -242,13 +254,13 @@
 void Model::remapVertex(Vertex *from, Vertex *to)
 {
-    from->remapTo(to);
+	from->remapTo(to);
 
 #ifdef LOG_LOWLEVEL_OPS
-    if( logfile )
-	*logfile << "v> " << from->uniqID+1 << " " << to->uniqID+1 << endl;
-#endif
-}
-
-
+	if( logfile )
+	{
+		*logfile << "v> " << from->uniqID+1 << " " << to->uniqID+1 << endl;
+	}
+#endif
+}
 
 void Model::contract(Vertex *v1,
@@ -257,92 +269,94 @@
 		     face_buffer& changed)
 {
-    int i;
-
-/*    if( logfile && selected_output&OUTPUT_CONTRACTIONS )
-    {
-	*logfile << "v% (" << v1->uniqID+1;
+	int i;
+
+	/*    if( logfile && selected_output&OUTPUT_CONTRACTIONS )
+				{
+	 *logfile << "v% (" << v1->uniqID+1;
+	 for(i=0; i<rest.length(); i++)
+	 *logfile << " " << rest(i)->uniqID+1;
+
+	 *logfile << ") " << to[X] << " " << to[Y] << " " << to[Z] << std::endl;
+	 }
+	 */
+
+	//
+	// Collect all the faces that are going to be changed
+	//
+	contractionRegion(v1, rest, changed);
+
+	reshapeVertex(v1, to[X], to[Y], to[Z]);
+
 	for(i=0; i<rest.length(); i++)
-	    *logfile << " " << rest(i)->uniqID+1;
-	
-	*logfile << ") " << to[X] << " " << to[Y] << " " << to[Z] << std::endl;
-    }
-*/
-
-    //
-    // Collect all the faces that are going to be changed
-    //
-    contractionRegion(v1, rest, changed);
-
-    reshapeVertex(v1, to[X], to[Y], to[Z]);
-
-    for(i=0; i<rest.length(); i++)
+	{
 		rest(i)->remapTo(v1);
-
-    removeDegeneracy(changed);
+	}
+
+	removeDegeneracy(changed);
 }
 
 void Model::maybeFixFace(Face *F)
 {
-    //
-    // Invalid faces do not need to be fixed.
+	//
+	// Invalid faces do not need to be fixed.
 #ifdef SAFETY
-    assert( F->isValid() );
-#endif
-
-    Vertex *v0=F->vertex(0); Vertex *v1=F->vertex(1); Vertex *v2=F->vertex(2);
-    Edge *e0 = F->edge(0); Edge *e1 = F->edge(1); Edge *e2 = F->edge(2);
-
-    bool a=(v0 == v1),  b=(v0 == v2),  c=(v1 == v2);
-
-    if( a && c )
-    {
-	// This triangle has been reduced to a point
-	killEdge(e0);
-	killEdge(e1);
-	killEdge(e2);
-
-	killFace(F);
-    }
-    //
-    // In the following 3 cases, the triangle has become an edge
-    else if( a )
-    {
-	killEdge(e0);
-	e1->remapTo(e2->sym());
-	killFace(F);
-    }
-    else if( b )
-    {
-	killEdge(e2);
-	e0->remapTo(e1->sym());
-	killFace(F);
-    }
-    else if( c )
-    {
-	killEdge(e1);
-	e0->remapTo(e2->sym());
-	killFace(F);
-    }
-    else
-    {
-	// This triangle remains non-degenerate
-/*		// SUS: recalcular la normal en los triangulos cambiados no degenerados
-
-		simplif::Vertex * auxv0 = F->vertex(0);
-		simplif::Vertex * auxv1 = F->vertex(1);
-		simplif::Vertex * auxv2 = F->vertex(2);
-		simplif::Vec3 vd1(auxv1->operator[](simplif::X) - auxv0->operator[](simplif::X), 
-						auxv1->operator[](simplif::Y) - auxv0->operator[](simplif::Y),
-						auxv1->operator[](simplif::Z) - auxv0->operator[](simplif::Z));
-		simplif::Vec3 vd2(auxv2->operator[](simplif::X) - auxv0->operator[](simplif::X), 
-						auxv2->operator[](simplif::Y) - auxv0->operator[](simplif::Y),
-						auxv2->operator[](simplif::Z) - auxv0->operator[](simplif::Z));
-
-		simplif::unitize(vd1);
-		simplif::unitize(vd2);
-
-		simplif::Vec3 vn = vd1 ^ vd2;
-		simplif::unitize(vn);
-		
+	assert( F->isValid() );
+#endif
+
+	Vertex *v0=F->vertex(0); Vertex *v1=F->vertex(1); Vertex *v2=F->vertex(2);
+	Edge *e0 = F->edge(0); Edge *e1 = F->edge(1); Edge *e2 = F->edge(2);
+
+	bool a=(v0 == v1),  b=(v0 == v2),  c=(v1 == v2);
+
+	if( a && c )
+	{
+		// This triangle has been reduced to a point
+		killEdge(e0);
+		killEdge(e1);
+		killEdge(e2);
+
+		killFace(F);
+	}
+	//
+	// In the following 3 cases, the triangle has become an edge
+	else if( a )
+	{
+		killEdge(e0);
+		e1->remapTo(e2->sym());
+		killFace(F);
+	}
+	else if( b )
+	{
+		killEdge(e2);
+		e0->remapTo(e1->sym());
+		killFace(F);
+	}
+	else if( c )
+	{
+		killEdge(e1);
+		e0->remapTo(e2->sym());
+		killFace(F);
+	}
+	else
+	{
+		// This triangle remains non-degenerate
+		/*		// SUS: recalcular la normal en los triangulos cambiados no degenerados
+
+					simplif::Vertex * auxv0 = F->vertex(0);
+					simplif::Vertex * auxv1 = F->vertex(1);
+					simplif::Vertex * auxv2 = F->vertex(2);
+					simplif::Vec3 vd1(auxv1->operator[](simplif::X) - auxv0->operator[](simplif::X), 
+					auxv1->operator[](simplif::Y) - auxv0->operator[](simplif::Y),
+					auxv1->operator[](simplif::Z) - auxv0->operator[](simplif::Z));
+					simplif::Vec3 vd2(auxv2->operator[](simplif::X) - auxv0->operator[](simplif::X), 
+					auxv2->operator[](simplif::Y) - auxv0->operator[](simplif::Y),
+					auxv2->operator[](simplif::Z) - auxv0->operator[](simplif::Z));
+
+					simplif::unitize(vd1);
+					simplif::unitize(vd2);
+
+					simplif::Vec3 vn = vd1 ^ vd2;
+					simplif::unitize(vn);
+
 		//auxf->vertex_normals[0] = vn;
 		//auxf->vertex_normals[1] = vn;
@@ -358,32 +372,38 @@
 		F->vertex_normals[2][simplif::Z] = vn[simplif::Z];*/
 
-    }
+	}
 }
 
 void Model::removeDegeneracy(face_buffer& changed)
 {
-    for(int i=0; i<changed.length(); i++)
+	for(int i=0; i<changed.length(); i++)
+	{
 		maybeFixFace(changed(i));
+	}
 }
 
 void Model::contractionRegion(Vertex *v1,
-			      const vert_buffer& vertices,
-			      face_buffer& changed)
-{
-    changed.reset();
-
-    //
-    // First, reset the marks on all reachable vertices
-    int i;
-
-    untagFaceLoop(v1);
-    for(i=0; i<vertices.length(); i++)
+			      									const vert_buffer& vertices,
+			      									face_buffer& changed)
+{
+	changed.reset();
+
+	// First, reset the marks on all reachable vertices
+	int i;
+
+	untagFaceLoop(v1);
+
+	for(i	=	0; i < vertices.length(); i++)
+	{
 		untagFaceLoop(vertices(i));
-
-    //
-    // Now, pick out all the unique reachable faces
-    collectFaceLoop(v1, changed);
-    for(i=0; i<vertices.length(); i++)
+	}
+
+	// Now, pick out all the unique reachable faces
+	collectFaceLoop(v1, changed);
+
+	for(i	=	0; i < vertices.length(); i++)
+	{
 		collectFaceLoop(vertices(i), changed);
+	}
 }
 
@@ -391,15 +411,15 @@
 void Model::contractionRegion(Vertex *v1, Vertex *v2, face_buffer& changed)
 {
-    changed.reset();
-
-    //
-    // Clear marks on all reachable faces
-    untagFaceLoop(v1);
-    untagFaceLoop(v2);
-
-    //
-    // Collect all the unique reachable faces
-    collectFaceLoop(v1, changed);
-    collectFaceLoop(v2, changed);
+	changed.reset();
+
+	//
+	// Clear marks on all reachable faces
+	untagFaceLoop(v1);
+	untagFaceLoop(v2);
+
+	//
+	// Collect all the unique reachable faces
+	collectFaceLoop(v1, changed);
+	collectFaceLoop(v2, changed);
 }
 
@@ -408,27 +428,20 @@
 {
 #ifdef SAFETY
-    assert( v1 != v2);
-#endif
-
-/*    if( logfile && selected_output&OUTPUT_CONTRACTIONS )
-	*logfile << "v% (" << v1->uniqID+1 << " " << v2->uniqID+1 << ") "
-		 << to[X] << " "
-		 << to[Y] << " "
-		 << to[Z] << std::endl;
-*/
-    //
-    // Collect all the faces that are going to be changed
-    //
-    contractionRegion(v1, v2, changed);
-
-    reshapeVertex(v1, to[X], to[Y], to[Z]);
-
-    //
-    // Map v2 ---> v1.  This accomplishes the topological change that we want.
-    v2->remapTo(v1);
-
-    removeDegeneracy(changed);
-}
-
+	assert( v1 != v2);
+#endif
+	//
+	// Collect all the faces that are going to be changed
+	//
+	contractionRegion(v1, v2, changed);
+
+	reshapeVertex(v1, to[X], to[Y], to[Z]);
+
+	// Map v2 ---> v1.  This accomplishes the topological change that we want.
+	v2->remapTo(v1);
+
+//	std::cout << "Contract(QslimInds): " << v2->validID() << " --> " << v1->validID() << std::endl;
+
+	removeDegeneracy(changed);
+}
 
 /*
@@ -494,2 +507,3 @@
 }
 */
+
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/gfx/tools/Buffer.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/gfx/tools/Buffer.h	(revision 1025)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/gfx/tools/Buffer.h	(revision 1526)
@@ -25,6 +25,6 @@
 		inline int length() const { return fill; }
 		inline int maxLength() const { return len; }
+		inline void setFill(int l){fill	=	l;}
 	};
-
 
 	template<class T>
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/gfx/tools/Heap.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/gfx/tools/Heap.h	(revision 1025)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/gfx/tools/Heap.h	(revision 1526)
@@ -16,31 +16,31 @@
 	class Heapable
 	{
-	private:
-		int token;
+		private:
 
-	public:
-		Heapable() { notInHeap(); }
+			int token;
 
-		inline int isInHeap() { return token!=NOT_IN_HEAP; }
-		inline void notInHeap() { token = NOT_IN_HEAP; }
-		inline int getHeapPos() { return token; }
-		inline void setHeapPos(int t) { token=t; }
+		public:
+
+			Heapable() { notInHeap(); }
+
+			inline int isInHeap() { return token!=NOT_IN_HEAP; }
+			inline void notInHeap() { token = NOT_IN_HEAP; }
+			inline int getHeapPos() { return token; }
+			inline void setHeapPos(int t) { token=t; }
 	};
 
+	class heap_node
+	{
+		public:
+			float import;
+			Heapable *obj;
 
-	class heap_node {
-	public:
-		float import;
-		Heapable *obj;
-
-		heap_node() { obj=NULL; import=0.0; }
-		heap_node(Heapable *t, float i=0.0) { obj=t; import=i; }
-		heap_node(const heap_node& h) { import=h.import; obj=h.obj; }
+			heap_node() { obj=NULL; import=0.0; }
+			heap_node(Heapable *t, float i=0.0) { obj=t; import=i; }
+			heap_node(const heap_node& h) { import=h.import; obj=h.obj; }
 	};
 
-
-
-	class Heap : public array<heap_node> {
-
+	class Heap : public array<heap_node>
+	{
 		//
 		// The actual size of the heap.  array::length()
@@ -57,9 +57,8 @@
 		void downheap(int i);
 
-	public:
+		public:
 
 		Heap() { size=0; }
 		Heap(int s) : array<heap_node>(s) { size=0; }
-
 
 		void insert(Heapable *, float);
@@ -67,11 +66,22 @@
 
 		heap_node *extract();
+
+		//	Overhead method.
+		heap_node *extract(int i);
+
 		heap_node *top() { return size<1 ? (heap_node *)NULL : &ref(0); }
 		heap_node *kill(int i);
+
+		//	Gets heap size.
+		int	getSize(){return	size;}
+
+		//	Gets element at position i.
+		heap_node	*getElement(int i){return	&ref(i);}
+
 	};
 
 }
 
-
 // GFXTOOLS_HEAP_INCLUDED
 #endif
+
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/gfx/tools/Array.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/gfx/tools/Array.h	(revision 1025)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/gfx/tools/Array.h	(revision 1526)
@@ -8,77 +8,76 @@
 {
 	template<class T>
-	class array {
-	protected:
-		T *data;
-		int len;
-	public:
-		array() { data=NULL; len=0; }
-		array(int l) { init(l); }
-		~array() { f_r_e_e(); }
+		class array
+		{
+			protected:
+				T *data;
+				int len;
+			public:
+				array() { data=NULL; len=0; }
+				array(int l) { init(l); }
+				~array() { f_r_e_e(); }
 
+				inline void init(int l);
+				inline void f_r_e_e();
+				inline void resize(int l);
 
-		inline void init(int l);
-		inline void f_r_e_e();
-		inline void resize(int l);
+				inline T& ref(int i);
+				inline T& operator[](int i) { return data[i]; }
+				inline T& operator()(int i) { return ref(i); }
 
-		inline T& ref(int i);
-		inline T& operator[](int i) { return data[i]; }
-		inline T& operator()(int i) { return ref(i); }
+				inline const T& ref(int i) const;
+				inline const T& operator[](int i) const { return data[i]; }
+				inline const T& operator()(int i) const { return ref(i); }
 
-		inline const T& ref(int i) const;
-		inline const T& operator[](int i) const { return data[i]; }
-		inline const T& operator()(int i) const { return ref(i); }
-
-
-		inline int length() const { return len; }
-		inline int maxLength() const { return len; }
-	};
+				inline int length() const { return len; }
+				inline int maxLength() const { return len; }
+		};
 
 	template<class T>
-	inline void array<T>::init(int l)
-	{
-		data = new T[l];
-		len = l;
-	}
+		inline void array<T>::init(int l)
+		{
+			data = new T[l];
+			len = l;
+		}
 
 	template<class T>
-	inline void array<T>::f_r_e_e()
-	{
-		if( data )
+		inline void array<T>::f_r_e_e()
 		{
-		delete[] data;
-		data = NULL;
+			if( data )
+			{
+				delete[] data;
+				data = NULL;
+			}
 		}
-	}
 
 	template<class T>
-	inline T& array<T>::ref(int i)
-	{
-	#ifdef SAFETY
-		assert( data );
-		assert( i>=0 && i<len );
-	#endif
-		return data[i];
-	}
+		inline T& array<T>::ref(int i)
+		{
+#ifdef SAFETY
+			assert( data );
+			assert( i>=0 && i<len );
+#endif
+			return data[i];
+		}
 
 	template<class T>
-	inline const T& array<T>::ref(int i) const
-	{
-	#ifdef SAFETY
-		assert( data );
-		assert( i>=0 && i<len );
-	#endif
-		return data[i];
-	}
+		inline const T& array<T>::ref(int i) const
+		{
+#ifdef SAFETY
+			assert( data );
+			assert( i>=0 && i<len );
+#endif
+			return data[i];
+		}
 
 	template<class T>
-	inline void array<T>::resize(int l)
-	{
-		T *old = data;
-		data = new T[l];
-		data = (T *)memcpy(data,old,MIN(len,l)*sizeof(T));
-		len = l;
-		delete[] old;
-	}
+		inline void array<T>::resize(int l)
+		{
+			T *old = data;
+			data = new T[l];
+			data = (T *)memcpy(data,old,MIN(len,l)*sizeof(T));
+			len = l;
+			delete[] old;
+		}
 }
 
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/gfx/tools/heap.cxx
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/gfx/tools/heap.cxx	(revision 1025)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/gfx/tools/heap.cxx	(revision 1526)
@@ -7,115 +7,127 @@
 void Heap::swap(int i,int j)
 {
-    heap_node tmp = ref(i);
+	heap_node tmp = ref(i);
 
-    ref(i) = ref(j);
-    ref(j) = tmp;
+	ref(i) = ref(j);
+	ref(j) = tmp;
 
-    ref(i).obj->setHeapPos(i);
-    ref(j).obj->setHeapPos(j);
+	ref(i).obj->setHeapPos(i);
+	ref(j).obj->setHeapPos(j);
 }
 
 void Heap::upheap(int i)
 {
-    if( i==0 ) return;
+	if( i==0 ) return;
 
-    if( ref(i).import > ref(parent(i)).import ) {
-        swap(i,parent(i));
-        upheap(parent(i));
-    }
+	if( ref(i).import > ref(parent(i)).import )
+	{
+		swap(i,parent(i));
+		upheap(parent(i));
+	}
 }
 
 void Heap::downheap(int i)
 {
-    if (i>=size) return;        // perhaps just extracted the last
+	if (i>=size) return;        // perhaps just extracted the last
 
-    int largest = i,
-        l = left(i),
-        r = right(i);
+	int largest = i,
+			l = left(i),
+			r = right(i);
 
-    if( l<size && ref(l).import > ref(largest).import ) largest = l;
-    if( r<size && ref(r).import > ref(largest).import ) largest = r;
+	if( l<size && ref(l).import > ref(largest).import ) largest = l;
+	if( r<size && ref(r).import > ref(largest).import ) largest = r;
 
-    if( largest != i ) {
-        swap(i,largest);
-        downheap(largest);
-    }
+	if( largest != i ) {
+		swap(i,largest);
+		downheap(largest);
+	}
 }
-
-
 
 void Heap::insert(Heapable *t,float v)
 {
-    if( size == maxLength() )
-    {
-	std::cerr << "NOTE: Growing heap from " << size << " to " << 2*size << std::endl;
-	resize(2*size);
-    }
+	if( size == maxLength() )
+	{
+		std::cerr << "NOTE: Growing heap from " << size << " to " << 2*size << std::endl;
+		resize(2*size);
+	}
 
-    int i = size++;
+	int i = size++;
 
-    ref(i).obj = t;
-    ref(i).import = v;
+	ref(i).obj = t;
+	ref(i).import = v;
 
-    ref(i).obj->setHeapPos(i);
+	ref(i).obj->setHeapPos(i);
 
-    upheap(i);
+	upheap(i);
 }
 
 void Heap::update(Heapable *t,float v)
 {
-    int i = t->getHeapPos();
+	int i = t->getHeapPos();
 
-    if( i >= size )
-    {
+	if( i >= size )
+	{
 		std::cerr << "WARNING: Attempting to update past end of heap!" << std::endl;
 		return;
-    }
-    else if( i == NOT_IN_HEAP )
-    {
+	}
+	else if( i == NOT_IN_HEAP )
+	{
 		std::cerr << "WARNING: Attempting to update object not in heap!" << std::endl;
 		return;
-    }
+	}
 
-    float old=ref(i).import;
-    ref(i).import = v;
+	float old=ref(i).import;
+	ref(i).import = v;
 
-    if( v<old )
-        downheap(i);
-    else
-        upheap(i);
+	if( v<old )
+		downheap(i);
+	else
+		upheap(i);
 }
-
-
 
 heap_node *Heap::extract()
 {
-    if( size<1 ) return 0;
+	if( size<1 ) return 0;
 
-    swap(0,size-1);
-    size--;
+	swap(0,size-1);
+	size--;
 
-    downheap(0);
+	downheap(0);
 
-    ref(size).obj->notInHeap();
+	ref(size).obj->notInHeap();
 
-    return &ref(size);
+	return &ref(size);
+}
+
+//	Overhead method.
+heap_node *Heap::extract(int i)
+{
+	if( size<1 ) return 0;
+
+	swap(i,size-1);
+	size--;
+
+	downheap(i);
+
+	ref(size).obj->notInHeap();
+
+	return &ref(size);
 }
 
 heap_node *Heap::kill(int i)
 {
-    if( i>=size )
+	if( i>=size )
 		std::cerr << "WARNING: Attempt to delete invalid heap node." << std::endl;
 
-    swap(i, size-1);
-    size--;
-    ref(size).obj->notInHeap();
+	swap(i, size-1);
+	size--;
+	ref(size).obj->notInHeap();
 
-    if( ref(i).import < ref(size).import )
+	if( ref(i).import < ref(size).import )
 		downheap(i);
-    else
+	else
 		upheap(i);
 
+	return &ref(size);
+}
 
-    return &ref(size);
-}
